<?php

declare(strict_types=1);

namespace Drupal\devel_visual\CropType;

use Drupal\Core\Config\Entity\ConfigEntityInterface;
use Drupal\Core\Entity\EntityStorageInterface;
use Drupal\crop\Entity\CropType as CropTypeBase;

class CropType extends CropTypeBase {

  protected static ?CropTypeAspectRatioComparer $comparer = NULL;

  /**
   * @phpstan-param \Drupal\Core\Config\Entity\ConfigEntityStorageInterface $storage
   * @phpstan-param array<string, static> $entities
   */
  public static function postLoad(
    EntityStorageInterface $storage,
    array &$entities,
  ): void {
    parent::postLoad($storage, $entities);
    uasort($entities, static::sort(...));
  }

  /**
   * {@inheritdoc}
   *
   * @noinspection PhpMissingParentCallCommonInspection
   */
  public static function sort(ConfigEntityInterface $a, ConfigEntityInterface $b): int {
    /** @var \Drupal\crop\CropTypeInterface $a */
    /** @var \Drupal\crop\CropTypeInterface $b */
    if (static::$comparer === NULL) {
      static::$comparer = new CropTypeAspectRatioComparer();
    }

    return static::$comparer->compare($a, $b);
  }

}
